/*  
 Esercizio 1: Lezione 12/03/10

 Scrivere un programma che legga una sequenza di stringhe e, mediante la tecnica del doubling, 
 costruisca un array di char contenente i caratteri della concatenazione di
 tutte le stringhe, quindi stampi in output la concatenazione.

*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#define MAXLEN 100


int main() {

 
  int dimensione = 0; // spazio attualmente occupato nel blocco 
  int capacita = 1;   // dimensione blocco corrente (inizialmente 1) 
  char *tmp;	      // puntatore ausiliario per la riallocazione	
  char *A; 	      // puntatore al blocco corrente 
  int i;
  char buff[MAXLEN+1];       // buffer contenente la stringa corrente	
  int len;  		     // lunghezza stringa corrente	
  
  A = (char *) malloc( sizeof(char)* capacita );
  if( A == NULL ) return 1;

  while( scanf("%s", buff) == 1) {          // il ciclo di inserzioni è terminato da EOF, da tastiera usare
					    // Ctrl+D/Ctrl+Z sotto Linux/Windows  
 
   len = strlen(buff);
    
    if( dimensione + len > capacita )        // se lo spazio di A non è sufficiente a contenere la nuova stringa
        { 				     // effettua la riallocazione:	
	 
          // porta la capacità del blocco alla più piccola potenza del due 
          // sufficiente ad ospitare la nuova stringa 
	  for (; dimensione + len > capacita; capacita *= 2);    
           
	  tmp = (char *) malloc( sizeof(char) * capacita );
	  if( tmp == NULL ) return 1;	
	  
	  // copia gli elementi nel nuovo blocco allocato 
	  for ( i = 0; i < dimensione; i++ ) 
	      tmp[i] = A[i];

	  free(A);                    // libera lo spazio occupato dal blocco di memoria precedente 
	  A = tmp;                    // A diventa il puntatore al nuovo blocco di memoria
      }

     // copia i caratteri della nuova stringa in fondo ad A ed 
     // aggiorna la variabile dimensione 

     for(i=0; buff[i] != '\0'; i++)
         A[dimensione++] = buff[i];
                         
  }  


  /* stampa tutti i caratteri di A */
 
    for (i=0; i<dimensione; i++)
     printf("%c",A[i]);

  /* 
   *  Attenzione: non è corretto stampare A con printf("%s",A) poichè A non è terminato da '\0'.    
   *  Una possibile alternativa è data dalla funzione fwrite <stdio.h> (vedi documentazione):   
   * 
   *    fwrite(A,dimensione,sizeof(char),stdout);     
   *  
   *  il cui effetto è stampare il numero specificato di elementi di A sullo standard output (stdout)  
   */
  

  

  return 0;
}
